<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>GenericTransformer xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/reverse/umlparser/GenericTransformer.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment">  */</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_comment"> * Copyright (c) 2010 Atos Origin.</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_comment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <em class="jxr_comment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <em class="jxr_comment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <em class="jxr_comment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <em class="jxr_comment"> * Contributors:</em>
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <em class="jxr_comment"> * Atos Origin - Initial API and implementation</em>
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <em class="jxr_comment"> ****************************************************/</em>
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.reverse.umlparser;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> java.util.Collection;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EClass;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EReference;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EStructuralFeature;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.resource.Resource;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.resource.ResourceSet;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.util.ECrossReferenceAdapter;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.util.EcoreUtil;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.util.EcoreUtil.UsageCrossReferencer;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.util.FeatureMapUtil;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <em class="jxr_javadoccomment"> * The Class GenericTransformer. Permits to transform an eobject of eclass to</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <em class="jxr_javadoccomment"> * another eclass</em>
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/GenericTransformer.html">GenericTransformer</a> {
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  	<em class="jxr_javadoccomment">/** element to transform */</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  	<strong class="jxr_keyword">private</strong> EObject element;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment">	 * Instantiates a new generic transformer.</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">	 * @param currentEobject</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">	 *            the current eobject</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/GenericTransformer.html">GenericTransformer</a>(EObject currentEobject) {
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		<strong class="jxr_keyword">this</strong>.element = currentEobject;
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	}
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <em class="jxr_javadoccomment">	 * Transform the element to the given eclass.</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_javadoccomment">	 * @param requestedType</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <em class="jxr_javadoccomment">	 *            the targeted eclass</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  	<strong class="jxr_keyword">public</strong> EObject transform(EClass requestedType) {
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  		<em class="jxr_comment">// Create the result</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  		EObject result = requestedType.getEPackage().getEFactoryInstance()
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  				.create(requestedType);
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  			<em class="jxr_comment">// Copy features</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  			copyAllFeatures(element, result);
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  			<em class="jxr_comment">// Change parent</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  			<em class="jxr_comment">// EcoreUtil.replace(element, result);</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			changeReferences(element, result);
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  			<em class="jxr_comment">// Change references on the old objet to references on the new</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  			<em class="jxr_comment">// object.</em>
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  			<em class="jxr_comment">// drop caches about input element</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  			ECrossReferenceAdapter cross = ECrossReferenceAdapter
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  					.getCrossReferenceAdapter(element);
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  			<strong class="jxr_keyword">if</strong> (cross != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  				cross.unsetTarget(element);
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  			}
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  		} <strong class="jxr_keyword">catch</strong> (Exception e) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  			<em class="jxr_comment">// TODO Auto-generated catch block</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  			e.printStackTrace();
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  		}
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  		<strong class="jxr_keyword">return</strong> result;
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  	}
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 * Copy the feature of the source into the target</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  <em class="jxr_javadoccomment">	 * @param element2</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  <em class="jxr_javadoccomment">	 * @param result</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> copyAllFeatures(EObject source, EObject target) {
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		EClass eclass = source.eClass();
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		<strong class="jxr_keyword">if</strong> (eclass != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 			EList&lt;EStructuralFeature&gt; eAllStructuralFeatures = eclass
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 					.getEAllStructuralFeatures();
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 			<strong class="jxr_keyword">for</strong> (EStructuralFeature structuralFeature : eAllStructuralFeatures) {
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 				<strong class="jxr_keyword">if</strong> (contains(target.eClass(), structuralFeature)) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 					copyFeature(source, target, structuralFeature);
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 				}
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 			}
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 		}
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 	}
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> <em class="jxr_javadoccomment">	 * check if the target eclass contains a estructuralfeature with the same</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> <em class="jxr_javadoccomment">	 * name less rigorous can work for many cases</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L119" href="#L119">119</a> <em class="jxr_javadoccomment">	 * @param target</em>
<a class="jxr_linenumber" name="L120" href="#L120">120</a> <em class="jxr_javadoccomment">	 *            the target</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> <em class="jxr_javadoccomment">	 * @param e</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> <em class="jxr_javadoccomment">	 *            the e</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> <em class="jxr_javadoccomment">	 * @return true, if successful</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">boolean</strong> contains(EClass target, EStructuralFeature e) {
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		EList&lt;EStructuralFeature&gt; features = target.getEAllStructuralFeatures();
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 		<strong class="jxr_keyword">for</strong> (EStructuralFeature f : features) {
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 			<strong class="jxr_keyword">if</strong> (f.getName().equals(e.getName())) {
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 			}
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		}
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 	}
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L137" href="#L137">137</a> <em class="jxr_javadoccomment">	 * Copy specified feature from source to target.</em>
<a class="jxr_linenumber" name="L138" href="#L138">138</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L139" href="#L139">139</a> <em class="jxr_javadoccomment">	 * @param mixedDomain</em>
<a class="jxr_linenumber" name="L140" href="#L140">140</a> <em class="jxr_javadoccomment">	 *            the mixed domain</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> <em class="jxr_javadoccomment">	 * @param source</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> <em class="jxr_javadoccomment">	 *            the source</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> <em class="jxr_javadoccomment">	 * @param target</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> <em class="jxr_javadoccomment">	 *            the target</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> <em class="jxr_javadoccomment">	 * @param feature</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> <em class="jxr_javadoccomment">	 *            the e</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 	@SuppressWarnings(<span class="jxr_string">"unchecked"</span>)
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> copyFeature(EObject source, EObject target,
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 			EStructuralFeature feature) {
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 		Collection&lt;Object&gt; alreadyManaged = <strong class="jxr_keyword">new</strong> ArrayList&lt;Object&gt;();
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 		<em class="jxr_comment">// Get the target feature</em>
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 		EStructuralFeature targetFeature = getFeature(target, feature.getName());
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 		<strong class="jxr_keyword">if</strong> (feature.getUpperBound() &lt;= targetFeature.getUpperBound()
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 				&amp;&amp; feature.getLowerBound() &gt;= targetFeature.getLowerBound()) {
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 			<strong class="jxr_keyword">if</strong> (feature.isChangeable() &amp;&amp; !feature.isDerived()) {
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 				Object value = source.eGet(feature);
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 				<strong class="jxr_keyword">if</strong> (feature.isMany() &amp;&amp; targetFeature.isMany()) {
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 					<em class="jxr_comment">// Collection to collection</em>
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 					Collection&lt;EObject&gt; values = (Collection&lt;EObject&gt;) value;
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 					<strong class="jxr_keyword">if</strong> (values != <strong class="jxr_keyword">null</strong> &amp;&amp; !values.isEmpty()) {
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 						Collection&lt;EObject&gt; newList = <strong class="jxr_keyword">new</strong> ArrayList&lt;EObject&gt;();
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 						newList.addAll(values);
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 						<strong class="jxr_keyword">if</strong> (feature instanceof EReference
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 								&amp;&amp; !((EReference) feature).isContainment()) {
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 							<em class="jxr_comment">// references</em>
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 							setFeatureValue(target, targetFeature, newList);
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 							<em class="jxr_comment">// add(new SetValueCommand(new</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 							<em class="jxr_comment">// SetRequest(editingDomain, target, targetFeature,</em>
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 							<em class="jxr_comment">// newList)));</em>
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 						} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (feature instanceof EReference
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 								&amp;&amp; ((EReference) feature).isContainment()) {
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 							<em class="jxr_comment">// Containement feature</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 							Collection&lt;Object&gt; toTreat = <strong class="jxr_keyword">new</strong> ArrayList&lt;Object&gt;();
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 							<strong class="jxr_keyword">for</strong> (Object o : newList) {
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 								<strong class="jxr_keyword">if</strong> (!alreadyManaged.contains(o)) {
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 									toTreat.add(o);
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 									alreadyManaged.add(o);
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 								}
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 							}
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 							setFeatureValue(target, targetFeature, newList);
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 						}
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 					}
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 				} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (!feature.isMany() &amp;&amp; !targetFeature.isMany()) {
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 					<em class="jxr_comment">// Copy one to one</em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 					<strong class="jxr_keyword">if</strong> (value != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 						<strong class="jxr_keyword">if</strong> (!alreadyManaged.contains(value)) {
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 							alreadyManaged.add(value);
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 							setFeatureValue(target, targetFeature, value);
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 						}
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 					}
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 				}
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 			}
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 		}
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 	}
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> <em class="jxr_javadoccomment">	 * Set the value of the specified feature</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L206" href="#L206">206</a> <em class="jxr_javadoccomment">	 * @param elementToEdit</em>
<a class="jxr_linenumber" name="L207" href="#L207">207</a> <em class="jxr_javadoccomment">	 * @param feature</em>
<a class="jxr_linenumber" name="L208" href="#L208">208</a> <em class="jxr_javadoccomment">	 * @param value</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> setFeatureValue(EObject elementToEdit,
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 			EStructuralFeature feature, Object value) {
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 		<strong class="jxr_keyword">boolean</strong> many = FeatureMapUtil.isMany(elementToEdit, feature);
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 		<strong class="jxr_keyword">if</strong> (many) {
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 			Collection collection = ((Collection) elementToEdit.eGet(feature));
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 			<strong class="jxr_keyword">if</strong> (value instanceof List) {
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 				List values = (List) value;
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 				collection.clear();
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 				collection.addAll(values);
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 				collection.add(value);
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 			}
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 			elementToEdit.eSet(feature, value);
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 		}
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 	}
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L229" href="#L229">229</a> <em class="jxr_javadoccomment">	 * Gets a feature from a name</em>
<a class="jxr_linenumber" name="L230" href="#L230">230</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L231" href="#L231">231</a> <em class="jxr_javadoccomment">	 * @param eobject</em>
<a class="jxr_linenumber" name="L232" href="#L232">232</a> <em class="jxr_javadoccomment">	 *            the eobject</em>
<a class="jxr_linenumber" name="L233" href="#L233">233</a> <em class="jxr_javadoccomment">	 * @param name</em>
<a class="jxr_linenumber" name="L234" href="#L234">234</a> <em class="jxr_javadoccomment">	 *            the name</em>
<a class="jxr_linenumber" name="L235" href="#L235">235</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L236" href="#L236">236</a> <em class="jxr_javadoccomment">	 * @return the feature</em>
<a class="jxr_linenumber" name="L237" href="#L237">237</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 	<strong class="jxr_keyword">private</strong> EStructuralFeature getFeature(EObject eobject, String name) {
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 		<strong class="jxr_keyword">return</strong> eobject.eClass().getEStructuralFeature(name);
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 	}
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L243" href="#L243">243</a> <em class="jxr_javadoccomment">	 * Replace all references on source by references on target Deletes the</em>
<a class="jxr_linenumber" name="L244" href="#L244">244</a> <em class="jxr_javadoccomment">	 * object from its {@link EObject#eResource containing} resource and/or its {@link EObject#eContainer containing} object as well as from any other</em>
<a class="jxr_linenumber" name="L245" href="#L245">245</a> <em class="jxr_javadoccomment">	 * feature that references it within the enclosing resource set, resource,</em>
<a class="jxr_linenumber" name="L246" href="#L246">246</a> <em class="jxr_javadoccomment">	 * or root object.</em>
<a class="jxr_linenumber" name="L247" href="#L247">247</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L248" href="#L248">248</a> <em class="jxr_javadoccomment">	 * @param eObject</em>
<a class="jxr_linenumber" name="L249" href="#L249">249</a> <em class="jxr_javadoccomment">	 *            the object to delete.</em>
<a class="jxr_linenumber" name="L250" href="#L250">250</a> <em class="jxr_javadoccomment">	 * @copyright org.eclipse.emf.ecore.util.EcoreUtil</em>
<a class="jxr_linenumber" name="L251" href="#L251">251</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> changeReferences(EObject source, EObject target) {
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 		EObject rootEObject = EcoreUtil.getRootContainer(source);
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 		Resource resource = rootEObject.eResource();
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 		Collection&lt;EStructuralFeature.Setting&gt; usages;
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 		<strong class="jxr_keyword">if</strong> (resource == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 			usages = UsageCrossReferencer.find(source, rootEObject);
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L260" href="#L260">260</a> 			ResourceSet resourceSet = resource.getResourceSet();
<a class="jxr_linenumber" name="L261" href="#L261">261</a> 			<strong class="jxr_keyword">if</strong> (resourceSet == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L262" href="#L262">262</a> 				usages = UsageCrossReferencer.find(source, resource);
<a class="jxr_linenumber" name="L263" href="#L263">263</a> 			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 				usages = UsageCrossReferencer.find(source, resourceSet);
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 			}
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 		}
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 		<strong class="jxr_keyword">for</strong> (EStructuralFeature.Setting setting : usages) {
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 			<strong class="jxr_keyword">if</strong> (setting.getEStructuralFeature().isChangeable()) {
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 				EcoreUtil.replace(setting, source, target);
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 			}
<a class="jxr_linenumber" name="L272" href="#L272">272</a> 		}
<a class="jxr_linenumber" name="L273" href="#L273">273</a> 
<a class="jxr_linenumber" name="L274" href="#L274">274</a> 		EcoreUtil.replace(source, target);
<a class="jxr_linenumber" name="L275" href="#L275">275</a> 	}
<a class="jxr_linenumber" name="L276" href="#L276">276</a> 
<a class="jxr_linenumber" name="L277" href="#L277">277</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
